C ______________________________	 Convert PM format to ASCII 
C		             November 1997         A. Klypin (aklypin@nmsu.edu) 
C		                     
C          Scales internal PM coordinates and velocities 
C          to  coordinates in Mpc/h and km/s
C          In PM the coordinates are in the range 1 - (NGRID+1)
C                     velocities are P = a_expansion*V_pec/(x_0H_0)
C                     where     x_0 = comoving cell_size=Box/Ngrid
C                                    H_0 = Hubble at z=0
C                   
C	     NROW = number of particles in 1D
C	     NGRID= number of cells        in 1D
       INCLUDE 'PMparameters.h'
       REAL     INPUT
       Character  FileASCII*50
C...................................................................
C			Read data and open files
      WRITE (*,'(A,$)') 'Enter File Name for ASCII data = '
      READ  (*,'(A)') FileASCII
      OPEN(17,FILE=FileASCII,STATUS='UNKNOWN')
      write (*,*) '============================================='
      write (*,*) ' starting RDTAPE'
      CALL RDTAPE
      write (*,*) ' RDTAPE is done'
      write (*,*) '============================================='
      write (*,*)
      
c      WRITE (17,100) HEADER,
c     +                  ASTEP,ISTEP,AEXPN,AEXP0,AMPLT,PARTW,
c     +                  EKIN,
c     +                  NROWC,NGRID,NRECL,Om0,Oml0,Ocurv,hubble,
c     +                  Nspecies
c100   FORMAT(1X,'#   Header  => ',A45,/
c     +            1X,'#   Step    =',F8.3,', IStep =',I4,/
c     +            1X,'#   A       =',F8.3,', A0    =',F8.3,
c     +               ', Ampl =',F8.3,/
c     +            1X,'#   WEIGHT  =',F8.3,', Ekin  =',E12.3,/
c     +            1X,'#   Nrow    =',I4,', Ngrid =',I4,', Nrecl =',I6,/
c     +            1x,'#   Omega_0 =',F7.3,', OmLam_0 =',F7.4,
c     +               ', Omega_curv =',F7.3,/
c     +            1x,'#   Hubble  =',F7.3,
c     +            1x,'#   Nspecies =',I2)

c      Box  =INPUT(' Enter box size in comoving Mpc/h = ')
      Box  = extras(100)

      write(17,'(A,I12,A)'),'#',NROWC**3,'         (no_part)'
      write(17,'(A,f12.5,A)'),'#',Box,'         (boxsize)'
      write(17,'(A,f12.5,A)'),'#',Om0,'         (omega0)'
      write(17,'(A,f12.5,A)'),'#',Oml0,'         (lambda0)'
      write(17,'(A,f12.5,A)'),'#',1.0,'         (pmass)'
      write(17,'(A,f12.5,A)'),'#',1./AEXP0-1.,'         (z_initial)'
      write(17,'(A,f12.5,A)'),'#',1./AEXPN-1.,'         (z_current)'
      write(17,'(A,I12,A)'),'#',0,'         (no_timestep)'
      write(17,'(A,A)'),'#',HEADER


      write(*,*)
      BoxV =Box*100.    ! Box size in km/s
      ScaleV = BoxV/AEXPN/NGRID  ! scale factor for Velocities (gives a*xdot)
      ScaleC = Box/NGRID         ! scale factor for Coordinates

      xmax =-1.e+9
      xmin = 1.e+9
      vmax =-1.e+9
      vmin = 1.e+9
      Icount =0
      ifile      =1
      If(Nspecies.eq.0)Then ! old case: 1 complete set
         Npages =NROW           ! Number of pages
         N_in_last=NPAGE        ! Number of particles in last page
      Else                      ! multiple masses
         N_particles =lspecies(Nspecies) ! Total number of particles
         Npages = (N_particles -1)/NPAGE +1
         N_in_last=N_particles -NPAGE*(Npages-1)
      EndIf
      write (*,*) ' Pages=',Npages,' Species=',Nspecies
      write (*,*) ' N_in_last=',N_in_last
C     Loop over particles
      DO IROW=1,Npages
         In_page =NPAGE
         If(IROW.eq.Npages)In_page =N_in_last
         write (*,*)' Read page=',IROW,' file=',ifile,' N=',In_page
         iL = NPAGE*(IROW-1)
         CALL GETROW(IROW,ifile)
         DO IN=1,In_page
            X  =ScaleC* (XPAR(IN)-1.)
            Y  =ScaleC* (YPAR(IN)-1.)
            Z  =ScaleC* (ZPAR(IN)-1.)
            Vxs=ScaleV* VX(IN)
            Vys=ScaleV* VY(IN)
            Vzs=ScaleV* VZ(IN)
            Icount =Icount +1
            xmax =MAX(xmax,X,Y,Z)
            xmin =MIN(xmin,X,Y,Z)
            vmax =MAX(vmax,Vxs,Vys,Vzs)
            vmin =MIN(vmin,Vxs,Vys,Vzs)
            If(Nspecies.eq.0)Then ! find weight of particle
               W =PARTW
            Else
               Ipart =IN+iL     ! current particle number
               Do i =1,Nspecies
                  if(Ipart.le.lspecies(i))Then
                     W =wspecies(i)
                     goto 50
                  endif 
               EndDo 
            EndIf
 50         write (17,200) X,Y,Z,Vxs,Vys,Vzs
 200        Format(3F18.8,3F18.8)
         ENDDO
      ENDDO 
      write (*,*)
      write (*,*) ' Scaled Coordinates were written to:',
     &     FileASCII
      write (*,*)
      write (*,*) ' Number of particles           =',Icount
      write (*,*) ' Min/Max of coordinates(Mpc/h) =',xmin,xmax
      write (*,*) ' Min/Max of velocities (km/s)  =',vmin,vmax
      
      END
      

